diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
similarity index 74%
rename from src/main/java/net/minecraft/client/render/RenderBlocks.java
rename to game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
index 2e169bec0..e3f4f1b23 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -854,20 +857,20 @@ public class RenderBlocks
         } else
         if(uvRotateNorth == 3)
         {
-            d3 = tex.getSubIconU(1 - block.minZ);
-            d4 = tex.getSubIconU(1 - block.maxZ);
-            d5 = tex.getSubIconV(block.maxY);
-            d6 = tex.getSubIconV(block.minY);
+            d3 = tex.getSubIconU(1 - bounds.minZ);
+            d4 = tex.getSubIconU(1 - bounds.maxZ);
+            d5 = tex.getSubIconV(bounds.maxY);
+            d6 = tex.getSubIconV(bounds.minY);
             d8 = d4;
             d9 = d3;
             d10 = d5;
             d11 = d6;
         }
-        double d12 = x + block.minX;
-        double d13 = y + block.minY;
-        double d14 = y + block.maxY;
-        double d15 = z + block.minZ;
-        double d16 = z + block.maxZ;
+        double d12 = x + bounds.minX;
+        double d13 = y + bounds.minY;
+        double d14 = y + bounds.maxY;
+        double d15 = z + bounds.minZ;
+        double d16 = z + bounds.maxZ;
         if(enableAO)
         {
         	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
@@ -891,26 +894,26 @@ public class RenderBlocks
         }
     }
 
-    public void renderEastFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex)
+    public void renderEastFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex)
     {
         if(overrideBlockTexture != null) tex = overrideBlockTexture;
         if (tex == null) return;
-        double uMin = tex.getSubIconU(block.minZ);
-        double uMax = tex.getSubIconU(block.maxZ);
-        double vMin = tex.getSubIconV(1 - block.maxY);
-        double vMax = tex.getSubIconV(1 - block.minY);
+        double uMin = tex.getSubIconU(bounds.minZ);
+        double uMax = tex.getSubIconU(bounds.maxZ);
+        double vMin = tex.getSubIconV(1 - bounds.maxY);
+        double vMax = tex.getSubIconV(1 - bounds.minY);
         if(flipTexture)
         {
             double _uMin = uMin;
             uMin = uMax;
             uMax = _uMin;
         }
-        if(block.minZ < 0.0D || block.maxZ > 1.0D)
+        if(bounds.minZ < 0.0D || bounds.maxZ > 1.0D)
         {
             uMin = tex.getIconUMin();
             uMax = tex.getIconUMax();
         }
-        if(block.minY < 0.0D || block.maxY > 1.0D)
+        if(bounds.minY < 0.0D || bounds.maxY > 1.0D)
         {
             vMin = tex.getIconVMin();
             vMax = tex.getIconVMax();
@@ -921,10 +924,10 @@ public class RenderBlocks
         double vMax2 = vMax;
         if(uvRotateSouth == 2)
         {
-            uMin = tex.getSubIconU(block.minY);
-            vMin = tex.getSubIconV(1 - block.minZ);
-            uMax = tex.getSubIconU(block.maxY);
-            vMax = tex.getSubIconV(1 - block.maxZ);
+            uMin = tex.getSubIconU(bounds.minY);
+            vMin = tex.getSubIconV(1 - bounds.minZ);
+            uMax = tex.getSubIconU(bounds.maxY);
+            vMax = tex.getSubIconV(1 - bounds.maxZ);
             vMin2 = vMin;
             vMax2 = vMax;
             uMax2 = uMin;
@@ -934,10 +937,10 @@ public class RenderBlocks
         } else
         if(uvRotateSouth == 1)
         {
-            uMin = tex.getSubIconU(1 - block.maxY);
-            vMin = tex.getSubIconV(block.maxZ);
-            uMax = tex.getSubIconU(1 - block.minY);
-            vMax = tex.getSubIconV(block.minZ);
+            uMin = tex.getSubIconU(1 - bounds.maxY);
+            vMin = tex.getSubIconV(bounds.maxZ);
+            uMax = tex.getSubIconU(1 - bounds.minY);
+            vMax = tex.getSubIconV(bounds.minZ);
             uMax2 = uMax;
             uMin2 = uMin;
             uMin = uMax2;
@@ -947,20 +950,20 @@ public class RenderBlocks
         } else
         if(uvRotateSouth == 3)
         {
-            uMin = tex.getSubIconU(1 - block.minZ);
-            uMax = tex.getSubIconU(1 - block.maxZ);
-            vMin = tex.getSubIconV(block.maxY);
-            vMax = tex.getSubIconV(block.minY);
+            uMin = tex.getSubIconU(1 - bounds.minZ);
+            uMax = tex.getSubIconU(1 - bounds.maxZ);
+            vMin = tex.getSubIconV(bounds.maxY);
+            vMax = tex.getSubIconV(bounds.minY);
             uMax2 = uMax;
             uMin2 = uMin;
             vMin2 = vMin;
             vMax2 = vMax;
         }
-        double xMax = x + block.maxX;
-        double yMin = y + block.minY;
-        double yMax = y + block.maxY;
-        double zMin = z + block.minZ;
-        double zMax = z + block.maxZ;
+        double xMax = x + bounds.maxX;
+        double yMin = y + bounds.minY;
+        double yMax = y + bounds.maxY;
+        double zMin = z + bounds.minZ;
+        double zMax = z + bounds.maxZ;
 
         if(enableAO)
         {
@@ -985,9 +988,9 @@ public class RenderBlocks
         }
     }
 
-    public void renderBlockAsItem(Tessellator tessellator, BlockModel<?> blockModel, Block block, float var2)
+    public void renderBlockAsItem(Tessellator tessellator, BlockModel<?> blockModel, float var2)
     {
-        blockModel.setBlockBoundsForItemRender();
+        AABB bounds = blockModel.getBlockBoundsForItemRender();
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
         float var5 = 0.5F;
         float var6 = 1.0F;
@@ -995,15 +998,15 @@ public class RenderBlocks
         float var8 = 0.6F;
         tessellator.startDrawingQuads();
         tessellator.setColorRGBA_F(var6, var6, var6, var2);
-        this.renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.BOTTOM, 0));
+        this.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.BOTTOM, 0));
         tessellator.setColorRGBA_F(var5, var5, var5, var2);
-        this.renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.TOP, 0));
+        this.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.TOP, 0));
         tessellator.setColorRGBA_F(var7, var7, var7, var2);
-        this.renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, 0));
-        this.renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.SOUTH, 0));
+        this.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, 0));
+        this.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.SOUTH, 0));
         tessellator.setColorRGBA_F(var8, var8, var8, var2);
-        this.renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.WEST, 0));
-        this.renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.EAST, 0));
+        this.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.WEST, 0));
+        this.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.EAST, 0));
         tessellator.draw();
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
     }
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
similarity index 99%
rename from src/main/java/net/minecraft/client/render/RenderGlobal.java
rename to game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 650671495..b54465e5e 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1300,7 +1300,7 @@ public class RenderGlobal
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.5F);
             GL11.glPushMatrix();
             int k = worldObj.getBlockId(hitResult.x, hitResult.y, hitResult.z);
-            Block block = k <= 0 ? null : Block.blocksList[k];
+            Block block = k <= 0 ? null : Blocks.blocksList[k];
             GL11.glDisable(GL11.GL_ALPHA_TEST);
             GL11.glPolygonOffset(-3F, -3F);
             GL11.glEnable(32823 /*GL_POLYGON_OFFSET_FILL*/);
@@ -1355,15 +1355,14 @@ public class RenderGlobal
                 int j = worldObj.getBlockId(hitResult.x, hitResult.y, hitResult.z);
                 if(j > 0)
                 {
-                    BoundingVolume volume = Block.blocksList[j].getBoundingVolume(worldObj, hitResult.x, hitResult.y, hitResult.z);
+                    BoundingVolume volume = Blocks.blocksList[j].getBoundingVolume(worldObj, hitResult.x, hitResult.y, hitResult.z);
                     if (volume != null)
                     {
                         drawOutlinedVolume(volume, hitResult.x - offsetX, hitResult.y - offsetY, hitResult.z - offsetZ, expand);
                     }
                     else
                     {
-                        Block.blocksList[j].setBlockBoundsBasedOnState(worldObj, hitResult.x, hitResult.y, hitResult.z);
-                        drawOutlinedBoundingBox(Block.blocksList[j].getSelectedBoundingBoxFromPool(worldObj, hitResult.x, hitResult.y, hitResult.z).grow(expand, expand, expand).cloneMove(-offsetX, -offsetY, -offsetZ));
+                        drawOutlinedBoundingBox(Blocks.blocksList[j].getSelectedBoundingBoxFromPool(worldObj, hitResult.x, hitResult.y, hitResult.z).grow(expand, expand, expand).cloneMove(-offsetX, -offsetY, -offsetZ));
                     }
                 }
             }
@@ -1735,7 +1734,7 @@ public class RenderGlobal
 
             case EVENT_BLOCK_BREAK: // Block break effect
                 if(data > 0) {
-                    Block block = Block.blocksList[data];
+                    Block block = Blocks.blocksList[data];
 
                     worldObj.playBlockSoundEffect(null, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, block, EnumBlockSoundEffectType.MINE);
                 }
diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/WorldRenderer.java
rename to game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 4e3219d1e..b69e8554a 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -7,6 +7,7 @@ import java.util.Random;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.phys.Vec3;
 import org.lwjgl.input.Mouse;
@@ -133,7 +134,7 @@ public class WorldRenderer
 		Vec3 pos2 = pos1.add(look.x * blockReach, look.y * blockReach, look.z * blockReach);
 		
 		// Raytrace blocks
-		mc.objectMouseOver = mc.currentWorld.checkBlockCollisionBetweenPoints(pos1, pos2);
+		mc.objectMouseOver = mc.currentWorld.checkBlockCollisionBetweenPoints(pos1, pos2, false, false, true);
 		
 		// Calculate again because block raytrace changes the values
 		pos1 = mc.thePlayer.getPosition(partialTicks, false);
@@ -806,18 +807,18 @@ public class WorldRenderer
             {
                 continue;
             }
-            if(Block.blocksList[i2].blockMaterial == Material.lava)
+            if(Blocks.blocksList[i2].blockMaterial == Material.lava)
             {
-                mc.particleEngine.add(new ParticleSmoke(world, (float)randX + f1, (double)((float)y + 0.1F) - Block.blocksList[i2].minY, (float)randZ + f2, 0.0D, 0.0D, 0.0D));
+                mc.particleEngine.add(new ParticleSmoke(world, (float)randX + f1, (double)((float)y + 0.1F) - Blocks.blocksList[i2].getBounds().minY, (float)randZ + f2, 0.0D, 0.0D, 0.0D));
                 continue;
             }
             if(random.nextInt(++l) == 0)
             {
                 d = (float)randX + f1;
-                d1 = (double)((float)y + 0.1F) - Block.blocksList[i2].minY;
+                d1 = (double)((float)y + 0.1F) - Blocks.blocksList[i2].getBounds().minY;
                 d2 = (float)randZ + f2;
             }
-            mc.particleEngine.add(new ParticleWaterDrop(world, (float)randX + f1, (double)((float)y + 0.1F) - Block.blocksList[i2].minY, (float)randZ + f2));
+            mc.particleEngine.add(new ParticleWaterDrop(world, (float)randX + f1, (double)((float)y + 0.1F) - Blocks.blocksList[i2].getBounds().minY, (float)randZ + f2));
         }
 
         if(l > 0 && random.nextInt(3) < rainSoundCounter++)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
similarity index 68%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModel.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index 02887fe03..8ba0c6fb7 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -1,129 +1,136 @@
-package net.minecraft.client.render.block.model;
-
-import net.minecraft.client.render.RenderBlocks;
-import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.WorldSource;
-import org.jetbrains.annotations.Nullable;
-
-public abstract class BlockModel<T extends Block>
-{
-    public static RenderBlocks renderBlocks;
-    public final T block;
-    protected boolean hasOverbright = false;
-    public BlockModel(Block block){
-        this.block = (T) block;
-    }
-    public abstract boolean render(Tessellator tessellator, int x, int y, int z);
-    public boolean renderNoCulling(Tessellator tessellator, int x, int y, int z) {
-        renderBlocks.renderAllFaces = true;
-        boolean result = render(tessellator, x, y, z);
-        renderBlocks.renderAllFaces = false;
-        return result;
-    }
-    public boolean renderWithOverrideTexture(Tessellator tessellator, int x, int y, int z, IconCoordinate textureIndex) {
-        renderBlocks.overrideBlockTexture = textureIndex;
-        boolean result = render(tessellator, x, y, z);
-        renderBlocks.overrideBlockTexture = null;
-        return result;
-    }
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, @Nullable Integer lightmapCoordinate){
-        renderBlockOnInventory(tessellator, metadata, brightness, 1f, lightmapCoordinate);
-    }
-    public abstract void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate);
-    public abstract boolean shouldItemRender3d();
-    public abstract float getItemRenderScale();
-
-    public abstract IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side);
-    public abstract IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, int side);
-    public abstract IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data);
-    public abstract IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data);
-    public abstract IconCoordinate getParticleTexture(Side side, int meta);
-    public abstract boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side, int meta);
-    public abstract boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side);
-    public abstract boolean shouldSideBeColored(WorldSource blockAccess, int x, int y, int z, int side, int meta);
-    public void setBlockBoundsForItemRender(){}
-    public boolean hasOverbright(){
-        return hasOverbright;
-    }
-    // Everything below is utility
-    public static void setRenderBlocks(RenderBlocks rb)
-    {
-        renderBlocks = rb;
-    }
-    public void resetRenderBlocks(){
-        renderBlocks.renderAllFaces = false;
-        renderBlocks.enableAO = false;
-//        renderBlocks.overbright = false;
-        renderBlocks.useInventoryTint = true;
-        renderBlocks.flipTexture = false;
-        renderBlocks.overrideBlockTexture = null;
-        renderBlocks.uvRotateEast = 0;
-        renderBlocks.uvRotateWest = 0;
-        renderBlocks.uvRotateSouth = 0;
-        renderBlocks.uvRotateNorth = 0;
-        renderBlocks.uvRotateTop = 0;
-        renderBlocks.uvRotateBottom = 0;
-        renderBlocks.field_22352_G = 1;
-        renderBlocks.renderBitMask = 0;
-    }
-    public void setRenderSide(Side side, boolean shouldRender){
-        if (!shouldRender){
-            renderBlocks.renderBitMask |= (byte) (1 << side.getId());
-        } else {
-            renderBlocks.renderBitMask &= (byte) ~(1 << side.getId());
-        }
-    }
-    public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z){
-        return renderBlocks.getBlockBrightness(blockAccess, x, y ,z);
-    }
-
-    public final boolean renderStandardBlock(Tessellator tessellator, Block block, int x, int y, int z){
-        return renderBlocks.renderStandardBlock(tessellator, (BlockModel<Block>) this, block, x, y, z);
-    }
-    public final boolean renderStandardBlock(Tessellator tessellator, Block block, int x, int y, int z, float r, float g, float b){
-        return renderBlocks.renderStandardBlock(tessellator, (BlockModel<Block>) this, block, x, y, z, r, g, b);
-    }
-    public final boolean renderSide(Tessellator tessellator, Block block, int x, int y, int z, Side side, int meta){
-        return renderBlocks.renderSide(tessellator, (BlockModel<Block>) this, block, x, y, z, 1, 1, 1, side, meta);
-    }
-    public final boolean renderSide(Tessellator tessellator, Block block, int x, int y, int z, float r, float g, float b, Side side, int meta){
-        return renderBlocks.renderSide(tessellator, (BlockModel<Block>) this, block, x, y, z, r, g, b, side, meta);
-    }
-    public final boolean renderSide(Tessellator tessellator, Block block, int x, int y, int z, float r, float g, float b, int side, int meta,
-                                    int dirX, int dirY, int dirZ, float depth,
-                                    int topX, int topY, int topZ, float topP, float botP,
-                                    int lefX, int lefY, int lefZ, float lefP, float rigP
-    ){
-        return renderBlocks.renderSide(tessellator, (BlockModel<Block>) this, block, x, y, z, r, g, b, side, meta,
-                dirX, dirY, dirZ, depth,
-                topX, topY, topZ, topP, botP,
-                lefX, lefY, lefZ, lefP, rigP);
-    }
-
-    public final void renderBottomFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderBottomFace(tessellator, block, x, y, z, tex);
-    }
-
-    public final void renderTopFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderTopFace(tessellator, block, x, y, z, tex);
-    }
-
-    public final void renderNorthFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderNorthFace(tessellator, block, x, y, z, tex);
-    }
-
-    public final void renderSouthFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderSouthFace(tessellator, block, x, y, z, tex);
-    }
-
-    public final void renderWestFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderWestFace(tessellator, block, x, y, z, tex);
-    }
-
-    public final void renderEastFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex){
-        renderBlocks.renderEastFace(tessellator, block, x, y, z, tex);
-    }
-}
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.RenderBlocks;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
+
+public abstract class BlockModel<T extends Block>
+{
+    public static RenderBlocks renderBlocks;
+    public final T block;
+    protected boolean hasOverbright = false;
+    public BlockModel(Block block){
+        this.block = (T) block;
+    }
+    public abstract boolean render(Tessellator tessellator, int x, int y, int z);
+    public boolean renderNoCulling(Tessellator tessellator, int x, int y, int z) {
+        renderBlocks.renderAllFaces = true;
+        boolean result = render(tessellator, x, y, z);
+        renderBlocks.renderAllFaces = false;
+        return result;
+    }
+    public boolean renderWithOverrideTexture(Tessellator tessellator, int x, int y, int z, IconCoordinate textureIndex) {
+        renderBlocks.overrideBlockTexture = textureIndex;
+        boolean result = render(tessellator, x, y, z);
+        renderBlocks.overrideBlockTexture = null;
+        return result;
+    }
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, @Nullable Integer lightmapCoordinate){
+        renderBlockOnInventory(tessellator, metadata, brightness, 1f, lightmapCoordinate);
+    }
+    public abstract void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate);
+    public abstract boolean shouldItemRender3d();
+    public abstract float getItemRenderScale();
+
+    public int renderLayer() {
+        return 0;
+    }
+
+    public abstract IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side);
+    public abstract IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, int side);
+    public abstract IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data);
+    public abstract IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data);
+    public abstract IconCoordinate getParticleTexture(Side side, int meta);
+    public abstract boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side, int meta);
+    public abstract boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side);
+    public abstract boolean shouldSideBeColored(WorldSource blockAccess, int x, int y, int z, int side, int meta);
+    public AABB getBlockBoundsForItemRender(){
+        return block.getBounds();
+    }
+    public boolean hasOverbright(){
+        return hasOverbright;
+    }
+    // Everything below is utility
+    public static void setRenderBlocks(RenderBlocks rb)
+    {
+        renderBlocks = rb;
+    }
+    public void resetRenderBlocks(){
+        renderBlocks.renderAllFaces = false;
+        renderBlocks.enableAO = false;
+//        renderBlocks.overbright = false;
+        renderBlocks.useInventoryTint = true;
+        renderBlocks.flipTexture = false;
+        renderBlocks.overrideBlockTexture = null;
+        renderBlocks.uvRotateEast = 0;
+        renderBlocks.uvRotateWest = 0;
+        renderBlocks.uvRotateSouth = 0;
+        renderBlocks.uvRotateNorth = 0;
+        renderBlocks.uvRotateTop = 0;
+        renderBlocks.uvRotateBottom = 0;
+        renderBlocks.field_22352_G = 1;
+        renderBlocks.renderBitMask = 0;
+    }
+    public void setRenderSide(Side side, boolean shouldRender){
+        if (!shouldRender){
+            renderBlocks.renderBitMask |= (byte) (1 << side.getId());
+        } else {
+            renderBlocks.renderBitMask &= (byte) ~(1 << side.getId());
+        }
+    }
+    public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z){
+        return renderBlocks.getBlockBrightness(blockAccess, x, y ,z);
+    }
+
+    public final boolean renderStandardBlock(Tessellator tessellator, AABB bounds, int x, int y, int z){
+        return renderBlocks.renderStandardBlock(tessellator, (BlockModel<Block>) this, bounds, x, y, z);
+    }
+    public final boolean renderStandardBlock(Tessellator tessellator, AABB bounds, int x, int y, int z, float r, float g, float b){
+        return renderBlocks.renderStandardBlock(tessellator, (BlockModel<Block>) this, bounds, x, y, z, r, g, b);
+    }
+    public final boolean renderSide(Tessellator tessellator,  AABB bounds, int x, int y, int z, Side side, int meta){
+        return renderBlocks.renderSide(tessellator, (BlockModel<Block>) this, bounds, x, y, z, 1, 1, 1, side, meta);
+    }
+    public final boolean renderSide(Tessellator tessellator,  AABB bounds, int x, int y, int z, float r, float g, float b, Side side, int meta){
+        return renderBlocks.renderSide(tessellator, (BlockModel<Block>) this, bounds, x, y, z, r, g, b, side, meta);
+    }
+    public final boolean renderSide(Tessellator tessellator,  AABB bounds, int x, int y, int z, float r, float g, float b, int side, int meta,
+                                    int dirX, int dirY, int dirZ, float depth,
+                                    int topX, int topY, int topZ, float topP, float botP,
+                                    int lefX, int lefY, int lefZ, float lefP, float rigP
+    ){
+        return renderBlocks.renderSide(tessellator, (BlockModel<Block>) this, bounds, x, y, z, r, g, b, side, meta,
+                dirX, dirY, dirZ, depth,
+                topX, topY, topZ, topP, botP,
+                lefX, lefY, lefZ, lefP, rigP);
+    }
+
+    public final void renderBottomFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
+        renderBlocks.renderBottomFace(tessellator, bounds, x, y, z, tex);
+    }
+
+    public final void renderTopFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
+        renderBlocks.renderTopFace(tessellator, bounds, x, y, z, tex);
+    }
+
+    public final void renderNorthFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
+        renderBlocks.renderNorthFace(tessellator, bounds, x, y, z, tex);
+    }
+
+    public final void renderSouthFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
+        renderBlocks.renderSouthFace(tessellator, bounds, x, y, z, tex);
+    }
+
+    public final void renderWestFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
+        renderBlocks.renderWestFace(tessellator, bounds, x, y, z, tex);
+    }
+
+    public final void renderEastFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex){
+        renderBlocks.renderEastFace(tessellator, bounds, x, y, z, tex);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
similarity index 81%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
index 3e15072e2..96f9e0069 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
 public class BlockModelAlgae<T extends Block> extends BlockModelStandard<T> {
@@ -15,7 +16,7 @@ public class BlockModelAlgae<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
         float brightness = 1.0f;
         if(!LightmapHelper.isLightmapEnabled()) {
         	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
@@ -30,8 +31,8 @@ public class BlockModelAlgae<T extends Block> extends BlockModelStandard<T> {
 
         tessellator.setColorOpaque_F(red * brightness, green * brightness, blue * brightness);
         IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.TOP, renderBlocks.blockAccess.getBlockMetadata(x, y, z));
-        renderTopFace(tessellator, block, x, y - 0.1125, z, tex);
-        renderBottomFace(tessellator, block, x, y + 0.0125, z, tex);
+        renderTopFace(tessellator, bounds, x, y - 0.1125, z, tex);
+        renderBottomFace(tessellator, bounds, x, y + 0.0125, z, tex);
 
         return true;
     }
@@ -40,14 +41,14 @@ public class BlockModelAlgae<T extends Block> extends BlockModelStandard<T> {
         return false;
     }
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
         if(side == 1)
         {
             return true;
         } else
         {
-            return super.shouldSideBeRendered(blockAccess, x, y, z, side);
+            return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
         }
     }
 }
